// 005 u_oracle_dbx_update_data
// 04 sep 2005

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com


(*$r+*)
unit u_oracle_dbx_update_data;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Db, DBTables, Grids, DBGrids, ComCtrls,
  DBXpress, SqlExpr, FMTBcd, DBClient, Provider;

type
  TForm1 = class(TForm)
    Panel4: TPanel;
    update_: TButton;
    Memo1: TMemo;
    Edit1: TEdit;
    insert_edit_: TButton;
    SQLConnection1: TSQLConnection;
    SQLQuery1: TSQLQuery;
    DataSetProvider1: TDataSetProvider;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    ClientDataSet1: TClientDataSet;
    select_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure update_Click(Sender: TObject);
    procedure insert_edit_Click(Sender: TObject);
    procedure select_Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
  uses u_c_log, u_c_display
    ;

    {$R *.DFM}

    const k_select_formations= 'SELECT * FROM formations';

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.update_Click(Sender: TObject);
        // -- hard coded values
      begin
        SqlConnection1.Open;

        with SqlQuery1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('UPDATE formations');
            Add('  SET f_nom= '+ QuotedStr('ORACLE Delphi'));
            Add('  WHERE f_numero= 3');
          end;

          display_strings(Sql);

          Try
            ExecSql;
            display('  ok');
          except
            on e: Exception do
              display('  *** pb_insert '+ e.Message);
          end;
        end; // with SqlQuery1
      end; // update_Click

    procedure TForm1.insert_edit_Click(Sender: TObject);
        // -- value from an Edit
      begin
(*
        with SqlQuery1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('INSERT INTO formations');
            Add('  (f_numero, f_nom)');
            Add('  VALUES (18, '''+ edit1.text+ ''')');
          end;

          display_strings(Sql);

          Try
            ExecSql;
            display('  ok');
          except
            on e: Exception do
              display('  *** pb_insert '+ e.Message);
          end;
        end; // with SqlQuery1
*)
      end; // insert_edit_Click

    // -- check with Select

    procedure select(p_query: String);
      var l_count: Integer;
      begin
        with Form1 do
        begin
          ClientDataset1.Close;
          with SqlQuery1 do
          begin
            Close;
            Sql.Text:= p_query;
            Open;
            l_count:= 0;
            While not Eof do
            begin
              Inc(l_count);
              Next;
            end; // while not Eot
            display('  ok, '+ IntToStr(l_count)+ ' lines');
          end; // with SqlQuery1
          ClientDataset1.Open;
        end; // with Form1
      end; // select

    procedure TForm1.select_Click(Sender: TObject);
      begin
        select(k_select_formations);
      end; // select_Click

    end.


